    001/* ===========================================================
    002 * Orson Charts : a 3D chart library for the Java(tm) platform
    003 * ===========================================================
    004 *
    005 * (C)opyright 2013-2022, by David Gilbert.  All rights reserved.
    006 *
    007 * https://github.com/jfree/orson-charts
    008 *
    009 * This program is free software: you can redistribute it and/or modify
    010 * it under the terms of the GNU General Public License as published by
    011 * the Free Software Foundation, either version 3 of the License, or
    012 * (at your option) any later version.
    013 *
    014 * This program is distributed in the hope that it will be useful,
    015 * but WITHOUT ANY WARRANTY; without even the implied warranty of
    016 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    017 * GNU General Public License for more details.
    018 *
    019 * You should have received a copy of the GNU General Public License
    020 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
    021 *
    022 * [Oracle and Java are registered trademarks of Oracle and/or its affiliates.
    023 * Other names may be trademarks of their respective owners.]
    024 *
    025 * If you do not wish to be bound by the terms of the GPL, an alternative
    026 * commercial license can be purchased.  For details, please see visit the
    027 * Orson Charts home page:
    028 *
    029 * http://www.object-refinery.com/orsoncharts/index.html
    030 *
    031 */
    032
    033package org.jfree.chart3d.data;
    034
    035import java.util.List;
    036
    037/**
    038 * A list of values that are associated with unique keys.
    039 *
    040 * @param <K>  the key type (must implement Comparable).
    041 * @param <T>  the value type.
    042 */
    043public interface KeyedValues<K extends Comparable<K>, T> extends Values<T> {
    044
    045    /**
    046     * Returns the key for the specified item in the list.
    047     *
    048     * @param index  the item index.
    049     *
    050     * @return The key.
    051     */
    052    K getKey(int index);
    053
    054    /**
    055     * Returns the index for the specified key, or {@code -1} if the key
    056     * is not present in the list.
    057     *
    058     * @param key  the key ({@code null} not permitted).
    059     *
    060     * @return The item index, or {@code -1}.
    061     */
    062    int getIndex(K key);
    063
    064    /**
    065     * Returns a list of all the keys.  Note that the list will be a copy, so
    066     * modifying it will not impact this data structure.
    067     *
    068     * @return A list of keys (possibly empty, but never {@code null}).
    069     */
    070    List<K> getKeys();
    071
    072    /**
    073     * Returns the value associated with the specified key, or
    074     * {@code null}.
    075     *
    076     * @param key  the key ({@code null} not permitted).
    077     *
    078     * @return The value (possibly {@code null}).
    079     */
    080    T getValue(K key);
    081
    082}